﻿using System;
using System.Collections.Generic;
using CevoAILib;
using CevoAILib.Diplomacy;

// This is version 1.0.3 from 13.09.2018



namespace AI
{		
	sealed class Empire : AEmpire
	{
		// Define Settler instances
		SettlerAdmin AdminSettlers = new SettlerAdmin();
		Settler[] Settlers = new Settler[256];
			
		// Define City instances
		CityAdmin AdminCities = new CityAdmin();
		XCity[] XCities = new XCity[256];
			
		// Define GridMap
		GridMap XGridMap = new GridMap();
	
		// Random Generator
		Random random = new Random();

        // Store City Location
        Location[] CityLocs = new Location[256];

        // Research Plan
        ResearchFunctions ResearchFunction = new ResearchFunctions();

        // Building Plan
        BuildingFunctions BuildingFunction = new BuildingFunctions();

        

        // City and Unit control
        int oldSettlerNum = 1;
        int newSettlerNum = 1;
		int assignedSettlerIndex = 0;
		int countSettlers = 0;
        bool foundUnitID = false;

        int oldCityNum = 1;
        int newCityNum = 1;
        int assignedCityIndex = 0;
		int countCities = 0;
        bool foundCityID = false;

        int CityCount = 0;
		bool newSettler;
        bool newCity;

        int ResearchCount = 0;
        int BuildingCount = 0;

        public Empire(int nationID, IntPtr serverPtr, IntPtr dataPtr, bool isNewGame)
			: base(nationID, serverPtr, dataPtr, isNewGame)
		{
		}
		
		protected override void NewGame()
		{
		}


		protected override void Resume()
		{
		}
					
		protected override void OnTurn()
		{
            // Initialize Research-Plan
            if (Turn == 0)
            {              
                ResearchFunction.AssignFirstResearchFunctions();
                BuildingFunction.AssignFirstBuildingFunctions();
            }

            // check if research complete
            if (HadEvent__Turn(EmpireEvent.ResearchComplete))
			{
                if (ResearchFunction.getResearchPlan(ResearchCount) != Advance.None)
                {
                    SetResearch__Turn(ResearchFunction.getResearchPlan(ResearchCount));
                    ResearchCount += 1;
                }
                if ((ResearchCount == 4) && (ResearchFunction.getResearchPlan(ResearchCount) != Advance.None))
                {
                    // start military research
                    Blueprint.SetDomain__Turn(ModelDomain.Ground);
                    Blueprint.SetProperty__Turn(ModelProperty.Weapons, 3);
                    Blueprint.SetProperty__Turn(ModelProperty.Armor, 2);
                    Blueprint.SetProperty__Turn(ModelProperty.Mobility, Blueprint.Stage.MaximumWeight - Blueprint.Weight);
                    SetResearch__Turn(Advance.MilitaryResearch);
                }
                    //if (random.Next(20) == 0)
                    //            { // start military research
                    //                Blueprint.SetDomain__Turn(ModelDomain.Ground);
                    //                Blueprint.SetProperty__Turn(ModelProperty.Weapons, 3);
                    //                Blueprint.SetProperty__Turn(ModelProperty.Armor, 1);
                    //                Blueprint.SetProperty__Turn(ModelProperty.Mobility, Blueprint.Stage.MaximumWeight - Blueprint.Weight);
                    //                SetResearch__Turn(Advance.MilitaryResearch);
                    //            }
                    //else
                    //{ 
                    // set random research
                    /*Advance newResearch = Advance.None;
                    int count = 0;
                    for (Advance testResearch = Advance.FirstCommon; testResearch <= Advance.LastFuture; testResearch++)
                    {
                        if (CanSetResearch__Turn(testResearch))
                        {
                            count++;
                            if (random.Next(count) == 0)
                                newResearch = testResearch;
                        }
                    }
                    if (newResearch != Advance.None)
                        SetResearch__Turn(newResearch);
                    */

                    // Advance newResearch = Advance.CeremonialBurial;

                    //}
                }
			
            // Set Anarchy and then Monarchy
            if ((ResearchCount == 8) && (Government == Government.Despotism))
            {
                Revolution__Turn();
            }
            if (HadEvent__Turn(EmpireEvent.AnarchyOver))
            {
                SetGovernment__Turn(Government.Monarchy);
            }

            // Initialize model Settler	
            Model modelSettlers = new Model(this, 0);
            Model pikenier = new Model(this, 1);
			
			// Initialize first Settler and City
			if (Turn == 0)
			{							
				foreach (Unit unit in Units) Settlers[0] = new Settler(unit.ID, 1);
                AdminSettlers.XSettlerJob[0] = SettlerToDo.BuildIrrigation;
                Settlers[0].settlerHasOrders = true;
                foreach (City city in Cities) XCities[0] = new XCity(city.ID, city.Location);
            }

			
			// Initialize first GridMap instances and Location of Home City
			if (Turn == 0)
			{				
				XGridMap = new GridMap();
				for (int i=0; i<9; i++) XGridMap.GridMapEntity[i] = new GridMapEntity();
				foreach (City city in Cities) CityLocs[0] = city.Location;
			}


            // Check for new Cities
            foreach (City city in Cities)
            {
                newCity = true;
                for (int i = 0; i < oldCityNum; i++)
                {
                    if (XCities[i].cID == city.ID) newCity = false;   
                }

                if (newCity == true)
                {
                    XCities[newCityNum] = new XCity(city.ID, city.Location);
                    newCityNum ++;
                }
            }
            oldCityNum = newCityNum;

			// Check for new Settler units			
			foreach (Unit unit in Units)
			{
				newSettler = true;
				for (int i=0; i<oldSettlerNum;i++)
				{
					if (Settlers[i].uID == unit.ID) newSettler = false;
				}
				
				if (newSettler == true)
				{									
				    Settlers[newSettlerNum] = new Settler(unit.ID, newSettlerNum + 1);
				    newSettlerNum ++;					
				}
			}
            oldSettlerNum = newSettlerNum;

			// Initializing City Grid Map for Home City
			if (Turn == 0)
			{
				foreach (City city in Cities)
				{
					XGridMap.GridMapEntity[0].GridLocation = city.Location;
					XGridMap.AssignFirstGridMapLocs(city.Location);
				}
			}

            // Start City commands
            foreach(City city in Cities)
            {
                // Retrieve corresponding City ID
                countCities = 0;
                foundCityID = false;
                do
                {
                    if (city.ID != XCities[countCities].cID) countCities += 1;
                    else
                    {
                        assignedCityIndex = countCities;
                        foundCityID = true;
                        countCities += 1;
                    }
                } while ((foundCityID == false) && (countCities != newCityNum));

                // Issue City Commands
                if (assignedCityIndex == 0)
                {
                    if ((city.Size >= 5) && (oldSettlerNum < 8))
                    {
                        city.OptimizeExploitedLocations__Turn(ResourceWeights.HurryProduction);
                        city.SetUnitInProduction__Turn(modelSettlers, UnitProductionOptions.None);
                    }
                    else if (ResearchCount >= 5)
                    {
                        city.SetUnitInProduction__Turn(pikenier, UnitProductionOptions.None);
                    }
                    else
                    {
                        city.OptimizeExploitedLocations__Turn(ResourceWeights.MaxGrowth);
                        city.StopProduction__Turn();
                    }
                }
                else
                {
                    if (city.Size < 4) city.OptimizeExploitedLocations__Turn(ResourceWeights.MaxGrowth);
                    else city.OptimizeExploitedLocations__Turn(ResourceWeights.HurryProduction);
                    city.SetBuildingInProduction__Turn(Building.Temple);

                    if ((BuildingFunction.getBuildingPlan(BuildingCount) != Building.None) && (Government != Government.Anarchy))
                    {
                        city.SetBuildingInProduction__Turn(BuildingFunction.getBuildingPlan(BuildingCount));
                        //if (HadEvent__Turn())
                        //{
                        //    SetGovernment__Turn(Government.Monarchy);
                        //}
                    }
                }
            }

            // Start Settler commands
            foreach (Unit unit in Units)
			{
			
				// Retrieve corresponding Settler ID
				countSettlers = 0;
				foundUnitID = false;
				do
				{
					if (unit.ID != Settlers[countSettlers].uID) countSettlers += 1;
					else
					{
						assignedSettlerIndex = countSettlers;
						foundUnitID = true;
						countSettlers += 1;
					} 
				} while ((foundUnitID == false) && (countSettlers != newSettlerNum));
					
				// Define City
				CityCount = 0;
				
				// Issue Settler Command
				if (Settlers[assignedSettlerIndex].settlerHasOrders == true)
				{
					// Do nothing
				}
				else
				{
					AdminSettlers.XSettlerJob[assignedSettlerIndex] = SettlerToDo.SeekNewSettleLocation;
					Settlers[assignedSettlerIndex].settlerHasOrders = true;
				}
				
				
							
				RC RelCoor = unit.Location - XCities[CityCount].cityLocation;
				AdminSettlers.commandSettlerMove(unit, RelCoor, Settlers[assignedSettlerIndex],
				                                 XCities, CityCount, assignedSettlerIndex, XGridMap, CityLocs);
			}
		}

		protected override void OnStealAdvance(Advance[] selection)
		{
			StealAdvance__Turn(selection[random.Next(selection.Length)]);
		}

		protected override void OnChanceToNegotiate(Phase situation, Nation Opponent, ref bool wantNegotiation, ref bool cancelTreatyIfRejected)
		{
			if (situation == Phase.BeginOfTurn) // start negotiation?
			{
				if (random.Next(30) == 0)
					wantNegotiation = true;
			}
			if (situation == Phase.ForeignTurn) // accept contact for negotiation?
			{
				if (random.Next(2) == 0)
					wantNegotiation = true;
			}
		}

		protected override void OnNegotiate(Negotiation negotiation)
		{
			if (negotiation.History.Count == 0 && RelationTo(negotiation.Opponent) < Relation.Alliance)
				negotiation.SetOurNextStatement(new SuggestTrade(new ITradeItem[] { new ChangeRelation(RelationTo(negotiation.Opponent) + 1) }, null)); // suggest better treaty
			if (negotiation.History.Count > 0 && negotiation.History[0].OpponentResponse is SuggestTrade)
			{
				SuggestTrade trade = negotiation.History[0].OpponentResponse as SuggestTrade;
				if ((trade.Offers.Length == 1 && trade.Wants.Length == 0 && trade.Offers[0] is ChangeRelation &&
					((ChangeRelation)trade.Offers[0]).NewRelation > RelationTo(negotiation.Opponent) ||
					(trade.Offers.Length == 0 && trade.Wants.Length == 1 && trade.Wants[0] is ChangeRelation &&
					((ChangeRelation)trade.Wants[0]).NewRelation > RelationTo(negotiation.Opponent))))
					negotiation.SetOurNextStatement(new AcceptTrade()); // accept better treaty
			}
		}

		protected override void OnForeignMove(IUnitInfo unit, Location destination)
		{
		}

		protected override void OnBeforeForeignAttack(IUnitInfo attacker, Location target, BattleOutcome outcome)
		{
		}

		protected override void OnAfterForeignAttack()
		{
		}

		protected override void OnBeforeForeignCapture(Nation nation, ICity city)
		{
		}

		protected override void OnAfterForeignCapture()
		{
		}
	}
}
