﻿/*
 * Created by SharpDevelop.
 * User: Andreas
 * Date: 29.01.2018
 * Time: 17:19
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using CevoAILib;

namespace AI
{	
	/// <summary>
	/// Description of GridMapEntity. This class holds the grid locations and their properties
	/// </summary>
	sealed class GridMapEntity
	{
		public Location GridLocation;
		public RelativeCoordinates RelCoor;
		public bool isWater;
		public bool isShore;
		public bool isLand;
		public bool isOnMap;
		public bool isVisible;
		public bool isExplored;
		public bool isNotReachable;

		public GridMapEntity()
		{
			isWater = false;
			isShore = false;
			isLand = false;
			isOnMap = true;
			isVisible = false;
			isExplored = false;
			isNotReachable = false;
		}
	}
	
	/// <summary>
	/// Description of GridMap.
	/// </summary>
	sealed class GridMap
	{
		public int numGridLocations;
		
		public GridMap()
		{
			numGridLocations = 1;
		}
		
		public GridMapEntity[] GridMapEntity = new GridMapEntity[1024];
		
		public void AssignFirstGridMapLocs(Location cityLoc)
		{

            GridMapEntity[1].GridLocation = cityLoc + new RC(-5, -5);
            GridMapEntity[1].RelCoor.a = -5;
            GridMapEntity[1].RelCoor.b = -5;
            GridMapEntity[2].GridLocation = cityLoc + new RC(0,-6);
			GridMapEntity[2].RelCoor.a = 0;
			GridMapEntity[2].RelCoor.b = -6;
			GridMapEntity[3].GridLocation = cityLoc + new RC(5,-5);
			GridMapEntity[3].RelCoor.a = 5;
			GridMapEntity[3].RelCoor.b = -5;
			GridMapEntity[4].GridLocation = cityLoc + new RC(6,0);
			GridMapEntity[4].RelCoor.a = 6;
			GridMapEntity[4].RelCoor.b = 0;
			GridMapEntity[5].GridLocation = cityLoc + new RC(5,5);
			GridMapEntity[5].RelCoor.a = 5;
			GridMapEntity[5].RelCoor.b = 5;
			GridMapEntity[6].GridLocation = cityLoc + new RC(0,6);
			GridMapEntity[6].RelCoor.a = 0;
			GridMapEntity[6].RelCoor.b = 6;
            GridMapEntity[7].GridLocation = cityLoc + new RC(-5,5);
			GridMapEntity[7].RelCoor.a = -5;
			GridMapEntity[7].RelCoor.b = 5;		
			GridMapEntity[8].GridLocation = cityLoc + new RC(-6,0);
			GridMapEntity[8].RelCoor.a = -6;
			GridMapEntity[8].RelCoor.b = 0;

			numGridLocations = 9;
		}
    }
}
